import tkinter as tk
import ressources
from elements import titre, texte
from constantes import *

class Commandes :
    def __init__(self, canevas) :
        self._canevas = canevas
        police = ressources.Polices().police('commandes')
        self._cmds = (
            ('GAUCHE', CMD_GAUCHE.replace('Left', '⬅')),
            ('DROITE', CMD_DROITE.replace('Right', '➡')),
            ('TIRER', CMD_TIRER),
            ('PAUSE', CMD_PAUSE),
        )
        titre.Titre(self._canevas, 'COMMANDES')
        hl, ll = 75, 150
        y, y2 = 200, 205 + len(self._cmds) * hl
        x = LARGEUR_ECRAN / 2 - ll
        x2 = LARGEUR_ECRAN / 2 + ll
        self._canevas.create_line(
            x, y, x2, y, x2, y2, x, y2, x, y,
            fill=C_CMD_CADRE,
            width=20,
            joinstyle='round',
            capstyle='round',
        )
        y = 200
        x = LARGEUR_ECRAN / 2
        for nom, cmd in self._cmds :
            self._canevas.create_rectangle(
                x-150, y, x+150, y+80,
                outline=C_CMD_LIGNE,
                width=5,
            )
            texte.Texte(
                self._canevas, x-20, y+40, nom,
                police, C_CMD_TXT, C_CMD_TXT_CONTOUR, anchor=tk.E
            )
            texte.Texte(
                self._canevas, x+20, y+40, cmd,
                police, C_CMD_TXT, C_CMD_TXT_CONTOUR, anchor=tk.W
            )
            y += 75
