module MODCommandes
    require 'tk'
    require './ressources'
    require './elements/texte'
    require './elements/titre'
    require './constantes'

    class Commandes
        def initialize canevas
            polices = MODRessources::Polices.new
            police = polices.police :commandes
            cmds = [
                ['GAUCHE', CMD_GAUCHE.sub('Left', '⬅')],
                ['DROITE', CMD_DROITE.sub('Right', '➡')],
                ['TIRER', CMD_TIRER],
                ['PAUSE', CMD_PAUSE],
            ]
            MODElements::Titre.new canevas, 'COMMANDES'
            hl, ll = 75, 150
            y, y2 = 200, 205 + cmds.length * hl
            x = LARGEUR_ECRAN / 2 - ll
            x2 = LARGEUR_ECRAN / 2 + ll
            canevas.create(
                :line,
                x, y, x2, y, x2, y2, x, y2, x, y,
                :fill=>C_CMD_CADRE,
                :width=>20,
                :joinstyle=>:round,
                :capstyle=>:round,
            )
            y = 200
            x = LARGEUR_ECRAN / 2
            cmds.each {|nom, cmd|
                canevas.create(
                    :rectangle,
                     x-150, y, x+150, y+80,
                    :outline=>C_CMD_LIGNE,
                    :width=>5,
                )
                MODElements::Texte.new(
                    canevas, x-20, y+40, nom, police,
                    C_CMD_TXT, C_CMD_TXT_CONTOUR, :anchor=>:e
                )
                MODElements::Texte.new(
                    canevas, x+20, y+40, cmd, police,
                    C_CMD_TXT, C_CMD_TXT_CONTOUR, :anchor=>:w
                )
                y += 75
            }
        end
    end
end
