import tkinter as tk

class Texte :
    _id = 0
    def __init__(
        self, canevas, x, y, texte, police, couleur,
        couleurContour, contour=1, **dargs
        ) :
        self._canevas = canevas
        self._coord = [x, y]
        self._texte = texte
        self._couleurs = [couleur, couleurContour]
        self._contour = contour
        self._tags = (
            'textes_%s' % self._id,
            'contours_textes_%s' % self._id
        )
        Texte._id += 1
        coords = self._genCoords(x, y)
        self._textes =  tuple(
            canevas.create_text(
                ax, ay,
                dargs,
                text=texte,
                fill=couleurContour,
                font=police,
                tags=self._tags,
            )
            for ax, ay in coords
        )
        self._canevas.dtag(self._textes[4], self._tags[1])
        self._canevas.itemconfig(self._textes[4], fill=couleur)
        self._canevas.tag_raise(self._textes[4], self._tags[1])

    def _genCoords(self, x, y) :
        return (
            (x+dx, y+dy)
            for dx in range(-self._contour, self._contour+1, self._contour)
            for dy in range(-self._contour, self._contour+1, self._contour)
        )

    @property
    def texte(self) :
        return self._texte

    @texte.setter
    def texte(self, texte) :
        self._texte = texte
        self._canevas.itemconfig(self._tags[0], text=texte)

    @property
    def coord(self) :
        return tuple(self._coord)

    @coord.setter
    def coord(self, coord) :
        self._coord[0] = coord[0]
        self._coord[1] = coord[1]
        for i, coord in enumerate(self._genCoords(*self._coord)) :
            self._canevas.coords(self._textes[i], *coord)

    @property
    def couleur(self) :
        return self._couleurs[0]

    @couleur.setter
    def couleur(self, couleur) :
        self._couleurs[0] = couleur
        self._canevas.itemconfig(self._textes[4], fill=couleur)

    @property
    def couleurContour(self) :
        return self._couleurs[1]

    @couleurContour.setter
    def couleurContour(self, couleur) :
        self._couleurs[1] = couleur
        self._canevas.itemconfig(self._tags[1], fill=couleur)

    @property
    def coords(self) :
        return self._canevas.bbox(self._tags[0])

    def montrer(self) :
        self._canevas.itemconfig(self._tags[0], state=tk.NORMAL)

    def cacher(self) :
        self._canevas.itemconfig(self._tags[0], state=tk.HIDDEN)

    def focus(self) :
        self._canevas.tag_raise(self._tags[0], tk.ALL)

    def detruire(self) :
        self._canevas.delete(self._tags[0])
