module MODElements
    require 'tk'
    class Texte
        @@id = 0
        def initialize canevas, x, y, texte, police, couleur,\
            couleurContour, contour:1, **dargs
            @canevas = canevas
            @coord = [x, y]
            @texte = texte
            @couleurs = [couleur, couleurContour]
            @contour = contour
            @tags = [
                "textes_#{@@id}",
                "contours_textes_#{@@id}",
            ]
            @@id += 1
            coords = genCoords x, y
            @textes = []
            coords.each {|ax, ay|
                @textes << @canevas.create(
                    :text,
                    ax, ay,
                    :text=>texte,
                    :fill=>couleurContour,
                    :font=>police,
                    :tags=>@tags,
                    **dargs
                )
            }
            @canevas.dtag @textes[4], @tags[1]
            @canevas.itemconfigure @textes[4], :fill=>couleur
            @canevas.raise @textes[4], @tags[1]
        end

        def genCoords x, y
            c = []
            (-@contour..@contour).step(@contour){|dx|
                (-@contour..@contour).step(@contour){|dy|
                    c << [x+dx, y+dy]
                }
            }
            c
        end
        private :genCoords

        def texte
            @texte
        end

        def texte=(str)
            @texte = str
            @canevas.itemconfigure @tags[0], :text=>str
        end

        def coord
            @coord.clone
        end

        def coord=(array)
            @coord = array.clone
            genCoords(*@coord).each_with_index{|coord, i|
                @canevas.coords @textes[i], *coord
            }
        end

        def couleur
            @couleurs[0]
        end

        def couleur=(str)
            @couleurs[0] = str
            @canevas.itemconfigure @texte[4], :fill=>str
        end

        def couleurContour
            @couleurs[1]
        end

        def couleurContour=(str)
            @couleurs[1] = str
            @canevas.itemconfigure @tags[1], :fill=>str
        end

        def coords
            @canevas.bbox @tags[0]
        end

        def montrer
            @canevas.itemconfigure @tags[0], :state=>:normal
        end

        def cacher
            @canevas.itemconfigure @tags[0], :state=>:hidden
        end

        def focus
            @canevas.raise @tags[0], :all
        end

        def detruire
            @canevas.delete @tags[0]
        end
    end
end
