from jeu.elements import elements
from constantes import *

def projectileCanon(canevas, x, y, x2, y2) :
    ''' Test et gestion des collisions du projectile canon '''
    el = elements.Elements()
    items = canevas.jeu.find_overlapping(x, y, x2, y2)
    collision = False
    for item in items :
        tags = canevas.jeu.gettags(item)
        if TAG_ALIEN in tags :
            collision = True
            points = el.aliens.points(item)
            el.score.incrementer(points)
            el.aliens.detruire(item)
            if not el.aliens.vivants :
                el.niveaux.terminer()
                break
        elif TAG_BLOC in tags :
            collision = True
            el.blocs.detruire(item)
        elif TAG_SOUCOUPE in tags :
            collision = True
            el.soucoupe.detruire()
            el.score.incrementer(el.soucoupe.points())
    return collision

def projectileAlien(canevas, x, y, x2, y2) :
    ''' Test et gestion des collisions du projectile alien '''
    el = elements.Elements()
    items = canevas.jeu.find_overlapping(x, y, x2, y2)
    collision = False
    for item in items :
        tags = canevas.jeu.gettags(item)
        if TAG_BLOC in tags :
            collision = True
            el.blocs.detruire(item)
        elif TAG_CANON in tags :
            collision = True
            viesRestantes = el.vies.decrementer()
            if viesRestantes :
                el.canon.infligerDegat()
            else :
                el.jeu.terminer(False)
    return collision


def aliens(canevas, aliens) :
    ''' Test et gestion des collisions des aliens '''
    el = elements.Elements()
    collision = False
    for alien in aliens :
        detruireAlien = False
        coords = canevas.jeu.bbox(alien.id)
        citems = canevas.jeu.find_overlapping(*coords)
        for citem in citems :
            tags = canevas.jeu.gettags(citem)
            if TAG_BLOC in tags :
                collision = True
                el.blocs.detruire(citem)
                detruireAlien = True
            elif TAG_CANON in tags :
                collision = True
                el.aliens.detruire(alien)
                el.jeu.terminer(False)
                return collision
            elif TAG_BASE in tags :
                collision = True
                el.jeu.terminer(False)
                return collision
        if detruireAlien :
            el.aliens.detruire(alien.id)
            if not el.aliens.vivants :
                el.niveaux.terminer()
                break
    return collision
