module MODJeu
    class Collisions
        require './jeu/elements/elements'
        require './constantes'
        def self.projectileCanon canevas, x, y, x2, y2
            # Test et gestion des collisions du projectile canon
            el = MODJeuElements::Elements.new
            ids = canevas.jeu.find_overlapping x, y, x2, y2
            collision = false
            ids.each {|id|
                tags = canevas.jeu.gettags(id)
                if tags.include? TAG_ALIEN
                    collision = true
                    points = el.aliens.points id
                    el.score.incrementer points
                    el.aliens.detruire id
                    if el.aliens.vivants == 0
                        el.niveaux.terminer
                    end
                    break
                elsif tags.include? TAG_BLOC
                    collision = true
                    el.blocs.detruire id
                elsif tags.include? TAG_SOUCOUPE
                    collision = true
                    el.soucoupe.detruire
                    el.score.incrementer el.soucoupe.points
                end
            }
            collision
        end

        def self.projectileAliens canevas, x, y, x2, y2
            # Test et gestion des collisions du projectile alien
            el = MODJeuElements::Elements.new
            ids = canevas.jeu.find_overlapping x, y, x2, y2
            collision = false
            ids.each {|id|
                tags = canevas.jeu.gettags id
                if tags.include? TAG_BLOC
                    collision = true
                    el.blocs.detruire id
                elsif tags.include? TAG_CANON
                    collision = true
                    viesRestantes = el.vies.decrementer
                    if viesRestantes > 0
                        el.canon.infligerDegat
                    else
                        el.jeu.terminer false
                    end
                end
            }
            collision
        end

        def self.aliens canevas, aliens
            # Test et gestion des collisions des aliens
            el = MODJeuElements::Elements.new
            collision = false
            aliens.each {|alien|
                detruireAlien = false
                ids = canevas.jeu.find_overlapping *alien.coords
                ids.each {|id|
                    tags = canevas.jeu.gettags id
                    if tags.include? TAG_BLOC
                        collision = true
                        el.blocs.detruire id
                        detruireAlien = true
                    elsif tags.include? TAG_CANON
                        collision = true
                        el.aliens.detruire alien.id
                        el.jeu.terminer false
                        return collision
                    elsif tags.include? TAG_BASE
                        collision = true
                        el.jeu.terminer false
                        return collision
                    end
                }
                if detruireAlien
                    el.aliens.detruire alien.id
                    if el.aliens.vivants == 0
                        el.niveaux.terminer
                        break
                    end
                end
            }
            collision
        end
    end
end
