from constantes import *

class Bloc :
    def __init__(self, canevas, x, y, largeur, hauteur, couleur) :
        self._canevas = canevas
        self._coords = (x, y, x + largeur, y + hauteur)
        self._couleur = couleur
        self._creer()

    @property
    def id(self) :
        return self._id

    def _creer(self) :
        self._id = self._canevas.create_rectangle(
            self._coords,
            fill=self._couleur,
            width=0,
            tags=TAG_BLOC,
        )

    def detruire(self) :
        self._canevas.delete(self._id)


class Blocs :
    def __init__(self, canevas) :
        self._canevas = canevas
        self._blocs = {}

    def creer(self) :
        self._couleurs = C_BLOCS
        largBlocs = DIM_BLOCS[0] * DIM_BLOC[0]
        margeBlocs = int((LARGEUR_ECRAN - NB_BLOCS * largBlocs) / NB_BLOCS)
        posBlocsX = int(margeBlocs / 2)
        for _ in range(NB_BLOCS) :
            self._creerZone(posBlocsX, posBlocsX + largBlocs)
            posBlocsX += largBlocs + margeBlocs

    def _creerZone(self, x, maxx) :
        i = 0
        for x in range(x, maxx, DIM_BLOC[0]) :
            maxy = BLOCS_Y + DIM_BLOCS[1] * DIM_BLOC[1]
            for y in range(BLOCS_Y, maxy, DIM_BLOC[1]) :
                bloc = Bloc(
                    self._canevas,
                    x, y,
                    DIM_BLOC[0], DIM_BLOC[1],
                    self._couleurs[i%2]
                )
                self._blocs[bloc.id] = bloc
                i += 1

    def detruire(self, id) :
        self._blocs[id].detruire()
        del(self._blocs[id])
