module MODJeuElements
    class Bloc
        require './constantes'
        attr_reader :id
        def initialize canevas, x, y, largeur, hauteur, couleur
            @canevas = canevas
            @coords = x, y, x + largeur, y + hauteur
            @couleur =  couleur
        end

        def creer
            @id = @canevas.create(
                :rectangle,
                *@coords,
                :fill=>@couleur,
                :width=>0,
                :tags=>TAG_BLOC,
            )
        end

        def detruire
            @canevas.delete @id
        end
    end


    class Blocs
        def initialize canevas
            @canevas = canevas
            @blocs = {}
        end

        def creer
            @couleurs = C_BLOCS
            largBlocs = DIM_BLOCS[0] * DIM_BLOC[0]
            marge = ((LARGEUR_ECRAN - NB_BLOCS * largBlocs) / NB_BLOCS).to_i
            x = (marge / 2).to_i
            (0...NB_BLOCS).each{
                creerZone x, x + largBlocs
                x += largBlocs + marge
            }
        end

        def creerZone px, pmax
            i = 0
            (px...pmax).step(DIM_BLOC[0]){|x|
                maxy = BLOCS_Y + DIM_BLOCS[1] * DIM_BLOC[1]
                (BLOCS_Y...maxy).step(DIM_BLOC[1]) {|y|
                    bloc = Bloc.new(
                        @canevas,
                        x, y,
                        DIM_BLOC[0], DIM_BLOC[1],
                        @couleurs[i%2]
                    )
                    bloc.creer
                    @blocs[bloc.id] = bloc
                    i += 1
                }
            }
        end
        private :creerZone

        def detruire id
            @blocs[id].detruire
            @blocs.delete id
        end
    end
end
