import tkinter as tk
import ressources
from . import projectile
from jeu import collisions
from constantes import *

class Canon :
    def __init__(self, canevas) :
        self._canevas = canevas
        self._images = ressources.Images()
        self._image = self._images.image('canon')
        self._projectile = ProjectileCanon(canevas)
        self._statuts = dict(
            projectile=True,
            mouvement=True,
        )

    def creer(self, x=None, y=None) :
        if x is None :
            x = LARGEUR_ECRAN / 2
        if y is None :
            y = HAUTEUR_ZONE_JEU
        self._id = self._canevas.jeu.create_image(
            x, y,
            image=self._image,
            tags=TAG_CANON,
            anchor=tk.S,
        )
        dl = int(self._image.width() / 2)
        self._ty = y - self._image.height() / 2
        self._pos = [x-dl, x+dl]

    def deplacer(self, direction) :
        if not self._statuts['mouvement'] :
            return
        if direction == DROITE and self._pos[1] + PAS_CANON < LARGEUR_ECRAN :
            self._canevas.jeu.move(self._id, PAS_CANON, 0)
            i = PAS_CANON
        elif direction == GAUCHE and self._pos[0] - PAS_CANON > 0 :
            self._canevas.jeu.move(self._id, -PAS_CANON, 0)
            i = -PAS_CANON
        else :
            return
        self._pos[0] += i
        self._pos[1] += i

    def tirer(self) :
        if self._projectile.actif or not self._statuts['projectile'] :
            return
        cx = self._pos[0] + int((self._pos[1] - self._pos[0]) / 2)
        self._projectile.creer(cx, self._ty)

    def infligerDegat(self) :
        imgDegat = self._images.image('canon', 1)
        self._canevas.jeu.itemconfigure(self._id, image=imgDegat)
        self._canevas.jeu.after(
            TEMPS_DEGAT_CANON,
            self._canevas.jeu.itemconfigure,
            self._id,
            {'image': self._image}
        )

    def detruire(self) :
        self.statuts(False)
        imgExplosion = self._images.image('canon', 2)
        self._canevas.jeu.itemconfigure(self._id, image=imgExplosion)
        self._canevas.jeu.after(
            TEMPS_EXPLOSION_CANON,
            self._canevas.jeu.delete,
            self._id
        )

    def statuts(self, booleen) :
        booleen = bool(booleen)
        for nom in self._statuts :
            self._statuts[nom] = booleen

    def _statut(self, nom, booleen) :
        ''' interne '''
        self._statuts[nom] = bool(booleen)

    mouvement = property(
        lambda self: self._statuts['mouvement'],
        lambda self, v: self._statut('mouvement', v),
    )
    projectile = property(
        lambda self: self._statuts['projectile'],
        lambda self, v: self._statut('projectile', v),
    )


class ProjectileCanon(projectile.Projectile) :
    def __init__(self, canevas) :
        super().__init__(canevas, C_PROJECTILE_CANON, TAG_PROJECTILE_CANON)

    def deplacer(self) :
        coords = self.coords
        col = collisions.projectileCanon(self._canevas, *coords)
        if not col and coords[3] > 0 :
            self._canevas.jeu.move(self._id, 0, -PAS_PROJECTILE_CANON)
            self._canevas.jeu.after(
                DELAI_DEPLACEMENT_PROJECTILE_CANON,
                self.deplacer,
            )
        else:
            self.detruire()
