class Projectile :
    def __init__(self, canevas, couleur, tags) :
        self._canevas = canevas
        self._id = None
        self._statut = True
        self._actif = False
        self._couleur = couleur
        self._tags = tags

    def creer(self, x, y) :
        if self._actif :
            return
        self._actif = True
        self._statut = True
        coords = (x-1, y+6, x+1, y-6)
        try :
            self._canevas.jeu.coords(self._id, coords)
        except :
            self._id = self._canevas.jeu.create_rectangle(
                coords,
                fill=self._couleur,
                width=0,
                tags=self._tags,
            )
        self._deplacer()

    def detruire(self) :
        self._statut = False
        self._actif = False
        self._canevas.jeu.coords(self._id, -10, -10, -10, -10)

    @property
    def statut(self) :
        return self._statut

    @statut.setter
    def statut(self, booleen) :
        self._statut = bool(booleen)

    @property
    def actif(self) :
        return self._actif

    @property
    def coords(self) :
        return self._canevas.jeu.coords(self._id)

    def _deplacer(self) :
        if not self._statut :
            return
        self.deplacer()

    def deplacer(self) :
        raise NotImplementedError
