module MODJeuElements
    class Projectile
        attr_reader :actif

        def initialize canevas, couleur, tags
            @canevas = canevas
            @id = nil
            @statut = true
            @actif = false
            @couleur = couleur
            @tags = tags
            @deplacer = lambda {_deplacer}
        end

        def creer x, y
            return if @actif
            @actif = true
            @statut = true
            coords = x-1, y+6, x+1, y-6
            if @id
                @canevas.jeu.coords @id, coords
            else
                @id = @canevas.jeu.create(
                    :rectangle,
                    *coords,
                    :fill=>@couleur,
                    :width=>0,
                    :tags=>@tags,
                )
            end
            @deplacer.call
        end

        def detruire
            @statut = false
            @actif = false
            @canevas.jeu.coords @id, [-10, -10, -10, -10]
        end

        def statut
            @statut
        end

        def statut=(bool)
            @statut = bool
        end

        def _deplacer
            return unless @statut
            deplacer
        end
        private :_deplacer

        def deplacer
            raise NotImplementedError
        end

        def coords
            @canevas.jeu.coords @id
        end
    end
end
