module MODJeu
    TAG_MESSAGE_CADRE = 'message_cadre'
    class Messages
        # Messages du jeu
        require 'tk'
        require './ressources'
        require './constantes'
        def initialize canevas
            @canevas = canevas
            @coords= 100, 200, LARGEUR_ECRAN - 100, 320
            @imageFond = MODRessources::Images.new.image :fond_message
            @couleurs = [C_MESSAGE_TXT, C_MESSAGE_TXT_CONTOUR].freeze
            @actif = false
            init
        end

        def texte
            @texte.texte
        end

        def texte=(str)
            if str.include? "\n"
                parts = str.split "\n"
                max = parts.max {|n, n2| n.length <=> n2.length}
                str = parts.map {|n| n = n.center max.length}.join "\n"
            end
            @texte.texte = str
        end

        def afficher
            @actif = true
            @canevas.raise TAG_MESSAGE_CADRE, :all
            @canevas.itemconfigure(TAG_MESSAGE_CADRE, :state=>:disabled)
            @texte.focus
            @texte.montrer
        end

        def effacer
            @actif = false
            @canevas.itemconfigure(TAG_MESSAGE_CADRE, :state=>:hidden)
            @texte.cacher
        end

        def actif?
            @actif
        end

        private
        def init
            x, y, x2, y2 = @coords
            # Fond
            polices = MODRessources::Polices.new
            (x...x2).step(50) {|xx|
                @canevas.create(
                    :image,
                    xx, y,
                    :image=>@imageFond,
                    :tag=>TAG_MESSAGE_CADRE,
                    :anchor=>:nw,
                )
            }
            # Bordures
            @canevas.create(
                :line,
                x+3, y+3, x2-5, y+3, x2-5, y2-5, x+3, y2-5, x+3, y+3,
                :width=>5,
                :fill=>C_MESSAGE_CADRE,
                :tag=>TAG_MESSAGE_CADRE,
                :stipple=>:gray75,
            )
            @texte = MODElements::Texte.new(
                @canevas,
                x+(x2-x)/2, y+(y2-y)/2,
                '',
                polices.police(:message),
                *@couleurs
            )
        end
    end
end
