import json
from jeu.elements import elements
from constantes import *

class Niveaux :
    ''' Gestion des niveaux du jeu '''
    def __init__(self, canevas) :
        self._canevas = canevas
        self._elements = elements.Elements()
        self._charger()
        self._actuel = 0

    def _charger(self) :
        ''' Interne '''
        with open(FICHIER_NIVEAUX, 'r') as f :
            self._niveaux = json.load(f)

    def niveau(self) :
        ''' Retourne les valeurs du niveau actuel '''
        return self._niveaux[self._actuel]

    def demarrer(self) :
        ''' Démarre le niveau actuel '''
        # Destruction canon après élimnation dernier alien du tableau
        if not self._elements.vies.vies :
            self._elements.jeu.terminer(False)
            return
        try :
            self._niveau = self.niveau()
        except IndexError :
            self._elements.jeu.terminer(True)
        else :
            self._message()
            self._canevas.jeu.after(DELAI_TRANSITION_NIVEAU, self._init)

    def terminer(self) :
        ''' Termine le niveau actuel, et relance le suivant '''
        self._elements.canon.projectile = False
        self._elements.soucoupe.apparition = False
        self._actuel += 1
        self._canevas.jeu.after(2000, self.demarrer)

    def _message(self) :
        ''' Interne '''
        self._elements.messages.texte = 'NIVEAU {}'.format(self._niveau['nom'])
        self._elements.messages.afficher()

    def _init(self) :
        ''' Interne '''
        self._elements.messages.effacer()
        self._elements.canon.projectile = True
        self._elements.soucoupe.apparition = True
        al = self._elements.aliens
        al.creer(self._niveau['aliens']['rangees'])
        al.vitesse = self._niveau['aliens']['vitesse']
        al.vitesseProjectile = self._niveau['projectile_alien']['vitesse']
        al.frequenceProjectile = self._niveau['projectile_alien']['frequence']
        al.mouvement = True
        al.projectile = True
        al.deplacer()
        al.tirer()
