module MODJeu
    class Niveaux
        # Gestion des niveaux du jeu
        require 'json'
        require './jeu/elements/elements'
        require './constantes'

        def initialize canevas
            @canevas = canevas
            @elements = MODJeuElements::Elements.new
            charger
            @actuel = 0
            @procs = {:init=>lambda {init},}
        end

        def niveau
            # Retourne les valeurs du niveau actuel
            @niveaux.fetch @actuel
        end

        def demarrer
            # Démarre le niveau actuel
            # Destruction canon après élimnation dernier alien du tableau
            if @elements.vies.vies == 0
                self._elements.jeu.terminer false
                return
            end
            begin
                @niveau = niveau
            rescue IndexError
                @elements.jeu.terminer true
            else
                message
                @canevas.jeu.after DELAI_TRANSITION_NIVEAU, @procs[:init]
            end
        end

        def terminer
            # Termine le niveau actuel, et relance le suivant
            @elements.canon.projectile = false
            @elements.soucoupe.apparition = false
            @elements.aliens.mouvement = false
            @elements.aliens.projectile = false
            @actuel += 1
            demarrer
        end

        private
        def charger
            f = File.new FICHIER_NIVEAUX, 'r'
            @niveaux = JSON.load(f, nil, {:symbolize_names=>true})
            f.close
        end

        def message
            @elements.messages.texte = "NIVEAU #{@niveau[:nom]}"
            @elements.messages.afficher
        end

        def init
            @elements.messages.effacer
            @elements.canon.projectile = true
            @elements.soucoupe.apparition = true
            aliens = @elements.aliens
            aliens.creer @niveau[:aliens][:rangees]
            aliens.vitesse = @niveau[:aliens][:vitesse]
            aliens.vitesseProjectile = @niveau[:projectile_alien][:vitesse]
            aliens.frequenceProjectile = @niveau[:projectile_alien][:frequence]
            aliens.mouvement = true
            aliens.projectile = true
            aliens.deplacer
            aliens.tirer
        end
    end
end
