'''
                 ._.     ___        _        ._.     ____
                ==-=     +-:+.     :+.      ==-=`    +---
                =        +  ::     =:;     :;        +
                :=_      +  =`    .= +     +         +___
                 --+.    +++-     :;_=:    =.        +---
                   ::    +        +-~:=    :;        |
                +;;+     +       :;   +.    ==;=:    +___
                ---      -       -    -`     ---     ----


     +    :=   +    |   :;     =;      +++;.     |=++.   :++=.     _+=.
     +    :+;  +    =:  =`    .=+      +. -+     + .     :: -+    :; -
     +    ::=. +    :=  +     :`=.     +   ::    +       ::  +    :;.
     +    ::-= +     + :;     + :;     +   ::    +++=    :;_=;     -+=.
     +    :: =:+     =::`    .++++     +   :`    +       :;-+        -=
     +    ::  ++     -=+     =`  =:    +. _=     | .     :: =.    .. .+
     +    ::  :+      +;     +   -=    +++=      ++++.   :: .=    -=+=`
'''
import tkinter as tk
import interfaces
from constantes import *

class SpaceInvaders(tk.Tk) :
    '''
    Classe maîtresse de l'application
    '''
    def __init__(self) :
        super().__init__()
        self.resizable(False, False)
        self.title('Space Invaders')
        posx = int((self.winfo_screenwidth() - LARGEUR_ECRAN) / 2)
        posy = int((self.winfo_screenheight() -  HAUTEUR_ECRAN) / 2)
        self.geometry('{}x{}+{}+{}'.format(
            LARGEUR_ECRAN,
            HAUTEUR_ECRAN,
            posx,
            posy
            )
        )
        self.configure(bg=C_FOND)
        self._interface = None

    def _ecran(self, nom, *args, **dargs) :
        '''
        Interne
        Détruit la précédente interface, crée la suivante
        '''
        try :
            self._interface.destroy()
        except AttributeError :
            pass
        self._interface = getattr(interfaces, nom)(self, *args, **dargs)

    def menu(self, animation=True) :
        self._ecran('Menu', animation=animation)

    def jeu(self) :
        self._ecran('Jeu')

    def commandes(self) :
        self._ecran('Commandes')

    def score(self) :
        self._ecran('Score')

    def lancer(self) :
        self.mainloop()


if __name__ == '__main__' :
    si = SpaceInvaders()
    si.menu(True)
    si.lancer()
