#                 ._.     ___        _        ._.     ____
#                ==-=     +-:+.     :+.      ==-=`    +---
#                =        +  ::     =:;     :;        +
#                :=_      +  =`    .= +     +         +___
#                 --+.    +++-     :;_=:    =.        +---
#                   ::    +        +-~:=    :;        |
#                +;;+     +       :;   +.    ==;=:    +___
#                ---      -       -    -`     ---     ----
#
#
#     +    :=   +    |   :;     =;      +++;.     |=++.   :++=.     _+=.
#     +    :+;  +    =:  =`    .=+      +. -+     + .     :: -+    :; -
#     +    ::=. +    :=  +     :`=.     +   ::    +       ::  +    :;.
#     +    ::-= +     + :;     + :;     +   ::    +++=    :;_=;     -+=.
#     +    :: =:+     =::`    .++++     +   :`    +       :;-+        -=
#     +    ::  ++     -=+     =`  =:    +. _=     | .     :: =.    .. .+
#     +    ::  :+      +;     +   -=    +++=      ++++.   :: .=    -=+=`

# $LOAD_PATH << __dir__
Dir.chdir(File.dirname(File.absolute_path($0)))

module SI
    require 'tk'
    class SpaceInvaders < TkRoot
        require './interfaces'
        require './constantes'
        def initialize infos
            super
            resizable false, false
            title 'Space Invaders'
            posx = (winfo_screenwidth.to_i - LARGEUR_ECRAN) / 2
            posy = (winfo_screenheight.to_i -  HAUTEUR_ECRAN) / 2
            geometry '%ix%i+%i+%i' % [LARGEUR_ECRAN, HAUTEUR_ECRAN, posx, posy]
            @interface = nil
            configure(:bg=>C_FOND)
        end

        def menu animation:true
            ecran :Menu, animation:animation
        end

        def jeu
            ecran :Jeu
        end

        def commandes
            ecran :Commandes
        end

        def score
            ecran :Score
        end

        def lancer
            mainloop
        end

        private
        def ecran(nom, args=nil, **dargs)
            params = [self]
            params << args if args
            cls = MODInterfaces.const_get(nom)
            if dargs.empty?
                interface = cls.new *params
            else
                interface = cls.new *params, **dargs
            end
            @interface.destroy if @interface
            @interface = interface
        end
    end
end

if __FILE__ == $0
    si = SI::SpaceInvaders.new
    si.menu animation:true
    si.lancer
end
