import ressources
from elements import texte
from constantes import *

class Elements :
    def __init__(self, canevas, animation=True, delai=0) :
        self._canevas = canevas
        self._animation = animation
        self._delai = delai

        self._polices = ressources.Polices()
        self._images = ressources.Images()
        self._policeTitre = self._polices.police('titre')

        self._ME = LARGEUR_ECRAN / 2
        self._items = (
            ('soucoupe', (-50, 200), (self._ME, 200), 2),
            ('alien_vert', (self._ME, 700), (self._ME, 250), 2),
            ('alien_jaune', (-50, 250), (self._ME - 50, 250), 2),
            ('alien_violet', (LARGEUR_ECRAN + 50, 250), (self._ME + 50, 250), 2),
        )

    def afficher(self) :
        self._initItems()
        if self._animation :
            self._animTitre()
            self._animElements()

    def _animTitre(self) :
        for size in range(-3, self._pt - 1, -1) :
            self._canevas.after(
                self._delai,
                self._policeTitre.__setitem__,
                'size',
                size
            )
            self._delai += 20

    def _animElements(self) :
        # Soucoupe
        el = self._items[0]
        dif = int(el[2][0] - el[1][0])
        for _ in range(dif) :
            self._canevas.after(
                self._delai,
                self._canevas.move,
                self._elements[0],
                1, 0
            )
            self._delai += el[3]
        self._delai += 50
        # alien central
        el = self._items[1]
        dif = int(el[1][1] - el[2][1])
        for _ in range(dif) :
            self._canevas.after(
                self._delai,
                self._canevas.move,
                self._elements[1],
                0, -1
            )
            self._delai += el[3]
        self._delai += 50
        # aliens latéraux
        def move() :
            self._canevas.move(self._elements[2], 1, 0)
            self._canevas.move(self._elements[3], -1, 0)

        el = self._items[2]
        dif = int(el[2][0] - el[1][0])
        for _ in range(dif) :
            self._canevas.after(
                self._delai,
                move
            )
            self._delai += el[3]
        self._delai += 50

    def _initItems(self) :
        if self._animation :
            self._pt = self._policeTitre['size']
            self._policeTitre['size'] = -3
            i = 1
        else :
            i = 2
        self._titre = texte.Texte(
            self._canevas,
            self._ME, 100,
            'SPACE INVADERS',
            self._policeTitre,
            C_MENU_TITRE_TXT,
            C_MENU_TITRE_TXT_CONTOUR,
            3
        )
        self._elements = []
        for item in self._items :
            elid = self._canevas.create_image(
                item[i],
                image=self._images.image(item[0])
            )
            self._elements.append(elid)

    delai = property(lambda s: s._delai)
