module MODMenu
    class Elements
        require './ressources'
        require './elements/texte'
        require './constantes'
        attr_reader :delai
        def initialize canevas, animation:true, delai:0
            @canevas = canevas
            @animation = animation
            @delai = delai

            @polices = MODRessources::Polices.new
            @images = MODRessources::Images.new
            @policeTitre = @polices.police :titre

            @ME = LARGEUR_ECRAN / 2
            @items = [
                ['soucoupe', [-50, 200], [@ME, 200], 2],
                ['alien_vert', [@ME, 700], [@ME, 250], 2],
                ['alien_jaune', [-50, 250], [@ME - 50, 250], 2],
                ['alien_violet', [LARGEUR_ECRAN + 50, 250], [@ME + 50, 250], 2],
            ]
        end

        def afficher
            initItems
            if @animation
                animTitre
                animElements
            end
        end

        private
        def animTitre
            -3.downto(@pt - 1) {|size|
                @canevas.after(
                    @delai,
                    lambda { @policeTitre.size=size }
                )
                @delai += 20
            }
        end

        def animElements
            # Soucoupe
            dif = @items[0][2][0] - @items[0][1][0]
            (0...dif).each {
                @canevas.after(
                    @delai,
                    lambda {@canevas.move(@elements[0], 1, 0)}
                )
                @delai += @items[0][3]
            }
            @delai += 50
            # alien central
            dif = @items[1][1][1] - @items[1][2][1]
            (0...dif).each {
                @canevas.after(
                    @delai,
                    lambda {@canevas.move(@elements[1], 0, -1)}
                )
                @delai += @items[1][3]
            }
            @delai += 50
            # aliens latéraux
            _move = lambda {
                @canevas.move(@elements[2], 1, 0)
                @canevas.move(@elements[3], -1, 0)
            }
            dif = @items[2][2][0] - @items[2][1][0]
            (0...dif).each {
                @canevas.after(
                    @delai,
                    _move
                )
                @delai += @items[2][3]
            }
            @delai += 50
        end

        def initItems
            if @animation
                @pt = @policeTitre.size
                @policeTitre.size = -3
                i = 1
            else
                i = 2
            end
            @titre = MODElements::Texte.new(
                @canevas,
                @ME, 100,
                'SPACE INVADERS',
                @policeTitre,
                C_MENU_TITRE_TXT,
                C_MENU_TITRE_TXT_CONTOUR,
                :contour=>3
            )
            @elements = []
            @items.each {|item|
                id = @canevas.create(
                    :image,
                    *item[i],
                    :image=>@images.image(item[0])
                )
                @elements << id
            }
        end
    end
end
