from elements import texte
from constantes import *

class BoutonMenu :
    def __init__(self, canevas, x, y, nom, commande) :
        import ressources
        self._polices = ressources.Polices()
        self._canevas = canevas
        self._nom = nom
        self._commande = commande
        self._couleursFocus = (
            C_MENU_BOUTON_TXT_ACTIF,
            C_MENU_BOUTON_TXT_ACTIF_CONTOUR,
        )
        self._couleursNormal = (
            C_MENU_BOUTON_TXT_NORMAL,
            C_MENU_BOUTON_TXT_NORMAL_CONTOUR,
        )
        self._texte = texte.Texte(
            self._canevas,
            x, y,
            nom,
            self._polices.police('bouton'),
            *self._couleursNormal
        )

    def focus(self) :
        self._texte.couleur = self._couleursFocus[0]
        self._texte.couleurContour = self._couleursFocus[1]

    def normal(self) :
        self._texte.couleur = self._couleursNormal[0]
        self._texte.couleurContour = self._couleursNormal[1]

    def executer(self) :
        self._commande()


class Menu :
    def __init__(self, canevas, attributs, iactif=0) :
        self._canevas = canevas
        self._iactif = iactif
        self._imax = len(attributs) - 1
        self._boutons = []
        x = 400
        y = 350
        for nom, commande in attributs :
            bouton = BoutonMenu(canevas, x, y, nom, commande)
            self._boutons.append(bouton)
            y += 60
        self._boutons[self._iactif].focus()
        self._dir = None
        self._time = 0

    def _parcourir(self, event, dir_) :
        if self._dir == dir_ and event.time - self._time < 150 :
            return
        self._time = event.time
        self._dir = dir_
        self._boutons[self._iactif].normal()
        if dir_ == HAUT :
            if self._iactif > 0 :
                self._iactif -= 1
            else :
                self._iactif = self._imax
        elif dir_ == BAS :
            if self._iactif < self._imax :
                self._iactif += 1
            else :
                self._iactif = 0
        self._boutons[self._iactif].focus()

    def _executer(self, event=None) :
        self._boutons[self._iactif].executer()

    def activer(self) :
        self._canevas.event_add(
            '<<haut>>',
            '<Up>', '<Shift-Tab>', '<ISO_Left_Tab>'
        )
        self._canevas.event_add('<<bas>>', '<Down>', '<Tab>')
        self._canevas.bind('<<haut>>', lambda e: self._parcourir(e, HAUT))
        self._canevas.bind('<<bas>>', lambda e: self._parcourir(e, BAS))
        self._canevas.bind('<Return>', self._executer)
