module MODMenu
    require './constantes'
    class BoutonMenu
        require './elements/texte'
        require './ressources'
        def initialize canevas, x, y, nom, commande
            @polices = MODRessources::Polices.new
            @canevas = canevas
            @x = x
            @y = y
            @nom = nom
            @commande = commande
            @couleursFocus = [
                C_MENU_BOUTON_TXT_ACTIF,
                C_MENU_BOUTON_TXT_ACTIF_CONTOUR,
            ]
            @couleursNormal = [
                C_MENU_BOUTON_TXT_NORMAL,
                C_MENU_BOUTON_TXT_NORMAL_CONTOUR,
            ]
            @texte = MODElements::Texte.new(
                @canevas,
                x, y,
                nom,
                @polices.police(:bouton),
                *@couleursNormal,
            )
        end

        def focus
            @texte.couleur = @couleursFocus[0]
            @texte.couleurContour = @couleursFocus[1]
        end

        def normal
            @texte.couleur = @couleursNormal[0]
            @texte.couleurContour = @couleursNormal[1]
        end

        def executer
            @commande.call
        end
    end


    class Menu
        def initialize canevas, attributs, iactif:0
            @canevas = canevas
            @iactif = iactif
            @imax = attributs.length - 1
            @boutons = []
            x, y = 400, 350
            attributs.each {|nom, commande|
                bouton = BoutonMenu.new @canevas, x, y, nom, commande
                @boutons << bouton
                y += 60
            }
            @boutons[@iactif].focus
            @dir = nil
            @time = 0
        end

        def executer
            @boutons[@iactif].executer
        end

        def activer
            evtHaut = TkVirtualEvent.new('Up', 'Shift-Tab', 'ISO_Left_Tab')
            evtBas = TkVirtualEvent.new('Down', 'Tab')
            @canevas.bind(evtHaut, lambda {|e| parcourir(e, HAUT)})
            @canevas.bind(evtBas, lambda {|e| parcourir(e, BAS)})
            @canevas.bind('Return', lambda {|e| executer})
        end

        def parcourir event, dir
            return if @dir == dir and event.time - @time < 150
            @time = event.time
            @dir = dir
            @boutons[@iactif].normal
            if dir == HAUT
                if @iactif > 0
                    @iactif -= 1
                else
                    @iactif = @imax
                end
            elsif dir == BAS
                if @iactif < @imax
                    @iactif += 1
                else
                    @iactif = 0
                end
            end
            @boutons[@iactif].focus
        end
    end
end
