import tkinter as tk
from tkinter import font as tkfont
from constantes import *

class Polices :
    _polices = dict()
    def __init__(self) :
        if not self._polices :
            self._init()

    def police(self, nom) :
        return self._polices[nom]

    def _init(self) :
        polices = dict(
            infos=tkfont.Font(size=-28, family='sans', weight='bold'),
            message=tkfont.Font(size=-24, family='monospace', weight='bold'),
            lien=tkfont.Font(size=-18, family='serif', weight='bold', slant='italic'),
            titre=tkfont.Font(size=-60, family='mono', weight='bold'),
            bouton=tkfont.Font(size=-32, family='serif', weight='bold'),
            iscore=tkfont.Font(size=-20, family='monospace', weight='bold'),
            commandes=tkfont.Font(size=-24, family='monospace', weight='bold'),
        )
        self._polices.update(polices)


class Images :
    _images = dict()
    def __init__(self) :
        if not self._images :
            self._init()

    def image(self, nom, indice=0) :
        return self._images[nom][indice]

    def _init(self) :
        import b64_images
        images = dict(
            canon=(
                tk.PhotoImage(data=b64_images.canon),
                tk.PhotoImage(data=b64_images.canon_degats),
                tk.PhotoImage(data=b64_images.canon_explosion),
            ),
            soucoupe=(
                tk.PhotoImage(data=b64_images.soucoupe),
                tk.PhotoImage(data=b64_images.soucoupe_explosion),
            ),
            fond_message=(tk.PhotoImage(data=b64_images.fond_message),),
        )

        for couleur in COULEURS_ALIENS :
            images['alien_' + couleur] = tuple(
                tk.PhotoImage(
                    data=getattr(
                        b64_images,
                        'alien_{}_{}'.format(couleur, type_)
                    )
                )
                for type_ in ('1', '2', 'explosion')
            )
        self._images.update(images)
