module MODRessources
    require 'tk'
    require './constantes'
    class Polices
        @@polices = {}
        def initialize
            init if @@polices.empty?
        end

        def police nom
            @@polices[nom]
        end

        private
        def init
            polices = {
                :infos=>TkFont.new(
                    :size=>-28, :family=>'sans', :weight=>'bold',
                ),
                :message=>TkFont.new(
                    :size=>-24, :family=>'monospace', :weight=>'bold',
                ),
                :lien=>TkFont.new(
                    :size=>-18, :family=>'serif', :weight=>'bold', :slant=>'italic',
                ),
                :titre=>TkFont.new(
                    :size=>-60, :family=>'mono', :weight=>'bold',
                ),
                :bouton=>TkFont.new(
                    :size=>-32, :family=>'serif', :weight=>'bold',
                ),
                :iscore=>TkFont.new(
                    :size=>-20, :family=>'monospace', :weight=>'bold',
                ),
                :commandes=>TkFont.new(
                    :size=>-24, :family=>'monospace', :weight=>'bold',
                ),
            }
            @@polices.update(polices)
        end
    end


    class Images
        require 'tkextlib/tkimg'
        require './b64_images'
        @@images = {}
        def initialize
            if @@images.empty?
                init
            end
        end

        def image nom, indice:0
            @@images[nom.to_sym][indice]
        end

        private
        def init
            images = {
                :canon => [
                    TkPhotoImage.new(:data=>MODB64Images::IMAGES[:canon]),
                    TkPhotoImage.new(:data=>MODB64Images::IMAGES[:canon_degats]),
                    TkPhotoImage.new(:data=>MODB64Images::IMAGES[:canon_explosion]),
                ],
                :soucoupe => [
                    TkPhotoImage.new(:data=>MODB64Images::IMAGES[:soucoupe]),
                    TkPhotoImage.new(:data=>MODB64Images::IMAGES[:soucoupe_explosion]),
                ],
                :fond_message => [
                    TkPhotoImage.new(:data=>MODB64Images::IMAGES[:fond_message]),
                ],
            }
            types = '1', '2', 'explosion'
            COULEURS_ALIENS.each {|couleur|
                id = "alien_#{couleur}".to_sym
                images[id] = []
                types.each {|type|
                    cle = "alien_#{couleur}_#{type}".to_sym
                     images[id] << TkPhotoImage.new(
                        :data=>MODB64Images::IMAGES[cle]
                    )
                }
            }
            @@images.update(images)
        end
    end
end
