import ressources
from elements import titre
from . import fichier
from constantes import *

class Score :
    def __init__(self, canevas) :
        self._canevas = canevas
        #self._scores = sorted(set(fichier.Fichier.charger()), reverse=True)
        self._scores = sorted(fichier.Fichier.charger(), reverse=True)
        self._polices = ressources.Polices()

    def afficher(self) :
        self._creerTitre()
        self._creerLignes()

    def _creerTitre(self) :
        titre.Titre(self._canevas, 'SCORES')

    def _creerLignes(self, lignes=10) :
        police = self._polices.police('iscore')
        couleurs = C_SCORES_LIGNES
        longLigne = len(str(lignes))
        h = 30
        y = 180
        x = 160
        x2 = LARGEUR_ECRAN - x
        y2 = y + lignes * h
        self._canevas.create_line(
            x, y, x2, y, x2, y2, x, y2, x, y,
            width=20,
            fill=C_SCORES_CADRE,
            joinstyle='round',
            capstyle='round',
        )
        for i in range(1, lignes+1) :
            self._canevas.create_rectangle(
                x, y, x2, y + h,
                fill=couleurs[i%2],
                width=0
            )
            self._canevas.create_text(
                x+20, y+h/2,
                text='{0:{l}}'.format(i, l=longLigne),
                font=police,
                fill=C_SCORES_NUMERO,
                anchor='w',
            )
            try :
                score = str(self._scores[i-1])
            except IndexError :
                continue
            else :
                self._canevas.create_text(
                    x+80, y+h/2,
                    text=score,
                    font=police,
                    fill=C_SCORES_SCORE,
                    anchor='w',
                )
            finally :
                y += h
