module MODScore
    class Score
        require './ressources'
        require './elements/titre'
        require './score/fichier'
        require './constantes'
        def initialize canevas
            @canevas = canevas
            @scores = MODScore::Fichier.charger
            #@scores.uniq!.sort!.reverse!
            @scores.sort!.reverse!
            @polices = MODRessources::Polices.new
        end

        def afficher
            creerTitre
            creerLignes
        end

        private
        def creerTitre
            MODElements::Titre.new @canevas, 'SCORES'
        end

        def creerLignes lignes:10
            police = @polices.police :iscore
            couleurs = C_SCORES_LIGNES
            longLignes = lignes.to_s.length
            h = 30
            y = 180
            x = 160
            x2 = LARGEUR_ECRAN - x
            y2 = y + lignes * h
            @canevas.create(
                :line,
                x, y, x2, y, x2, y2, x, y2, x, y,
                :width=>20,
                :fill=>C_SCORES_CADRE,
                :joinstyle=>:round,
                :capstyle=>:round,
            )
            (1..lignes).each {|i|
                @canevas.create(
                    :rectangle,
                    x, y, x2, y + h,
                    :fill=>couleurs[i%2],
                    :width=>0
                )
                @canevas.create(
                    :text,
                    x+20, y+h/2,
                    :text=>i.to_s.rjust(longLignes),
                    :font=>police,
                    :fill=>C_SCORES_NUMERO,
                    :anchor=>:w,
                )
                begin
                    score = @scores.fetch(i-1)
                    @canevas.create(
                        :text,
                        x+80, y+h/2,
                        :text=>score,
                        :font=>police,
                        :fill=>C_SCORES_SCORE,
                        :anchor=>:w,
                    )
                rescue IndexError
                    next
                ensure
                    y += h
                end
            }
        end
    end
end
